_ = require 'lodash'
http = require 'http'

class PublishMessage
  constructor: (options={}) ->
    {
      @firehoseClient
      @uuidAliasResolver
    } = options

  _doCallback: (request, code, callback) =>
    response =
      metadata:
        responseId: request.metadata.responseId
        code: code
        status: http.STATUS_CODES[code]
    callback null, response

  do: (request, callback) =>
    {fromUuid, messageType} = request.metadata

    message = request.rawData
    @_send {fromUuid, messageType, message}, (error) =>
      return callback error if error?
      return @_doCallback request, 204, callback

  _send: ({fromUuid,messageType,message}, callback=->) =>
    @uuidAliasResolver.resolve fromUuid, (error, uuid) =>
      return callback error if error?
      @firehoseClient.publish "#{uuid}", message, callback

module.exports = PublishMessage
